//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include <stdio.h>
#include <dos.h>
#include "Unit1.h"
#include "Serial.h"
#include "SerInterface.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "cspin"
#pragma resource "*.dfm"

#define CMD_SUCCESS "Status: Command OK"
#define CMD_FAILED  "Status: Command ERROR"
#define CMD_WAIT    "Status: Wait"

TForm1 *Form1;
static unsigned char ucBuffer[65535];
static char Parameter[256]="9600,N,8,1";
static TimeAndDate_t  TimeAndDate;
static uint8_t ActualFileHandle=0;

const char Port[]="COM2";
const char Parameter9600[]="9600,N,8,1";
const char Parameter115200[]="115200,N,8,1";

const TimeAndDate_t DummyTime= { 0,0,0,1,1,1980 };

void __fastcall TForm1::EnableButtons(TObject *Sender)
{
  MOUNTButton->Enabled=true;
  UNMOUNTButton->Enabled=true;
  OPENButton->Enabled=true;
  CLOSEButton->Enabled=true;
  READButton->Enabled=true;
  WRITEButton->Enabled=true;
  FORMATButton->Enabled=true;
  CREATEDIRButton->Enabled=true;
  CHANGEDIRButton->Enabled=true;
  SEEKButton->Enabled=true;
  RENAMEButton->Enabled=true;
  RENAMEButton->Enabled=true;
  REMOVEButton->Enabled=true;
  WRITEENABLEButton->Enabled=true;
  WRITEDISABLEButton->Enabled=true;
  CONNECTButton->Enabled=true;
  DISCONNECTButton->Enabled=true;
  INITDISPLAYButton->Enabled=true;
  CLEARDISPLAYButton->Enabled=true;
  DIRButton->Enabled=true;
  DISPLAYWRITEButton->Enabled=true;
  DISPLAYONButton->Enabled=true;
  DISPLAYOFFButton->Enabled=true;
  BAUDRATEButton->Enabled=true;
  CARDSTATUSButton->Enabled=true;
  DIRECTIONButton->Enabled=true;
  WRITEOUTPUTButton->Enabled=true;
  PULLUPButton->Enabled=true;
  READINPUTButton->Enabled=true;
  CARDAVAILABLEButton->Enabled=true;
  CARDNOTAVAILABLEButton->Enabled=true;
  TELLButton->Enabled=true;
  FIRMWAREButton->Enabled=true;
  FileHandleRadioButton1->Enabled=true;
  FileHandleRadioButton2->Enabled=true;
  FileHandleRadioButton3->Enabled=true;
  FileHandleRadioButton4->Enabled=true;
  PingButton->Enabled=true;
}

void __fastcall TForm1::DisableButtons(TObject *Sender)
{
  MOUNTButton->Enabled=false;
  UNMOUNTButton->Enabled=false;
  OPENButton->Enabled=false;
  CLOSEButton->Enabled=false;
  READButton->Enabled=false;
  WRITEButton->Enabled=false;
  FORMATButton->Enabled=false;
  CREATEDIRButton->Enabled=false;
  CHANGEDIRButton->Enabled=false;
  SEEKButton->Enabled=false;
  RENAMEButton->Enabled=false;
  RENAMEButton->Enabled=false;
  REMOVEButton->Enabled=false;
  WRITEENABLEButton->Enabled=false;
  WRITEDISABLEButton->Enabled=false;
  CONNECTButton->Enabled=false;
  DISCONNECTButton->Enabled=false;
  INITDISPLAYButton->Enabled=false;
  CLEARDISPLAYButton->Enabled=false;
  DIRButton->Enabled=false;
  DISPLAYWRITEButton->Enabled=false;
  DISPLAYONButton->Enabled=false;
  DISPLAYOFFButton->Enabled=false;
  BAUDRATEButton->Enabled=false;
  CARDSTATUSButton->Enabled=false;
  DIRECTIONButton->Enabled=false;
  WRITEOUTPUTButton->Enabled=false;
  PULLUPButton->Enabled=false;
  READINPUTButton->Enabled=false;
  CARDAVAILABLEButton->Enabled=false;
  CARDNOTAVAILABLEButton->Enabled=false;
  TELLButton->Enabled=false;
  FIRMWAREButton->Enabled=false;
  FileHandleRadioButton1->Enabled=false;
  FileHandleRadioButton2->Enabled=false;
  FileHandleRadioButton3->Enabled=false;
  FileHandleRadioButton4->Enabled=false;
  PingButton->Enabled=false;
}


////////////////////////////////////////////////////////////////////////////////
// DecodeDate
////////////////////////////////////////////////////////////////////////////////
static void ConvertPCTime(void)
{
struct  time t;
struct date d;

  getdate(&d);
  gettime(&t);

  TimeAndDate.Second=t.ti_sec;
  TimeAndDate.Hour=t.ti_hour;
  TimeAndDate.Minute=t.ti_min;
  TimeAndDate.Day=d.da_day;
  TimeAndDate.Month=d.da_mon;
  TimeAndDate.Year=d.da_year;
}


////////////////////////////////////////////////////////////////////////////////
// DecodeDate
////////////////////////////////////////////////////////////////////////////////
static void DecodeDate(uint16_t Date, uint8_t *pDate)
{
uint16_t d;
  d=Date & 0x001F; // bit 0-4 day of month
  if (d>9)
    *pDate++='0'+(d / 10);
  else
    *pDate++=' ';
  *pDate++='0'+(d % 10);
  *pDate++='.';
  d=(Date & 0x01E0) >> 5; // bit 5-8 month of year
  if (d>9)
    *pDate++='0'+(d/10);
  else
    *pDate++=' ';
  *pDate++='0'+(d % 10);
  *pDate++='.';
  d=(Date & 0xFE00) >> 9; // bit 9-15 years from 1980
  d=d+1980;
  *pDate++='0'+(d / 1000);
  d=d % 1000;
  *pDate++='0'+(d / 100);
  d=d % 100;
  *pDate++='0'+(d / 10);
  *pDate++='0'+(d % 10);
  *pDate++=' ';
}


////////////////////////////////////////////////////////////////////////////////
// DecodeTime
////////////////////////////////////////////////////////////////////////////////
static void DecodeTime(uint16_t Time, uint8_t *pTime)
{
uint16_t t;
  t=(Time & 0xF800) >> 11; // bit 11-15 hours
  if (t>9)
    *pTime++='0'+(t / 10);
  else
    *pTime++=' ';
  *pTime++='0'+(t % 10);
  *pTime++=':';
  t=(Time & 0x07E0) >> 5; // bit 5-10 minutes
  if (t>9)
    *pTime++='0'+(t / 10);
  else
    *pTime++=' ';
  *pTime++='0'+(t % 10);
  *pTime++=' ';
}


////////////////////////////////////////////////////////////////////////////////
// DecodeSize
////////////////////////////////////////////////////////////////////////////////
static void DecodeSize(uint32_t s,uint8_t *pData)
{
uint32_t div=1000000000;
  while (div >= 10)
  {
    if ((s / div)>0)
      *pData++='0'+(s / div);
    else
      *pData++=' ';
    s=s % div;
    div=div/10;
  }
  if ((s % div)>0)
    *pData++='0'+(s % div);
  else
    *pData++=' ';
  *pData++=' ';
}

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}

//---------------------------------------------------------------------------

void __fastcall TForm1::OPENSERIALButtonClick(TObject *Sender)
{
char port[256];
  strcpy(port,Port);
  try
  {
    port[3]='0'+CSpinEdit1->Value;
  }
  catch (...)
  {
    strcpy(port,Port);
  }
  if (OpenSerialPort(port, Parameter))
  {
    EnableButtons(Sender);
    OPENSERIALButton->Enabled=false;
    PortLabel->Caption="Serial Port Open";
  }
}
//---------------------------------------------------------------------------


void __fastcall TForm1::MOUNTButtonClick(TObject *Sender)
{
  StatusLabel->Caption=CMD_WAIT; Form1->Refresh();
  if (Mount_())
    StatusLabel->Caption=CMD_SUCCESS;
  else
    StatusLabel->Caption=CMD_FAILED;
}


//---------------------------------------------------------------------------

void __fastcall TForm1::UNMOUNTButtonClick(TObject *Sender)
{
  StatusLabel->Caption=CMD_WAIT; Form1->Refresh();
  if (UnMount_())
    StatusLabel->Caption=CMD_SUCCESS;
  else
    StatusLabel->Caption=CMD_FAILED;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::OPENButtonClick(TObject *Sender)
{
AnsiString s;
  StatusLabel->Caption=CMD_WAIT; Form1->Refresh();
  s=ParameterEdit1->Text+"           ";
  if (FileOpen_(ActualFileHandle, s.c_str(), FILEOPENMODE_READONLY,DummyTime))
    StatusLabel->Caption=CMD_SUCCESS;
  else
    StatusLabel->Caption=CMD_FAILED;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CLOSEButtonClick(TObject *Sender)
{
  ConvertPCTime();
  StatusLabel->Caption=CMD_WAIT; Form1->Refresh();
  if (FileClose_(ActualFileHandle,TimeAndDate))
    StatusLabel->Caption=CMD_SUCCESS;
  else
    StatusLabel->Caption=CMD_FAILED;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::READButtonClick(TObject *Sender)
{
int x,y;
AnsiString s,t;

  StatusLabel->Caption=CMD_WAIT; Form1->Refresh();

  y=FileRead_(ActualFileHandle, ucBuffer, 512, 1);

  ListBox1->Clear();
  s="";
  t="";

  // Die letzten drei Bytes sind die Checksumme und werden nicht als Nutzdaten verwendet
  y=y-3;

  for (x=0; x<y; x++)
  {
    if ((x % 16)==0)
    {
      s=s+"  "+t;
      ListBox1->Items->Add(s);
      s="";
      t="";
    }
    s=s+" "+IntToHex(ucBuffer[x],2);
    if (ucBuffer[x])
      t=t+(char)ucBuffer[x];
    else
      t=t+" ";
  }
  if (s!="")
    ListBox1->Items->Add(s);

  // Checksumme der Daten berprfen
  if (((ucBuffer[y+0] ^ ucBuffer[y+1])== ucBuffer[y+2]) && ucBuffer[y+1]!=0)
    StatusLabel->Caption=CMD_SUCCESS;
  else
    StatusLabel->Caption=CMD_FAILED;
}
//---------------------------------------------------------------------------


void __fastcall TForm1::SEEKButtonClick(TObject *Sender)
{
uint32_t Position;

  StatusLabel->Caption=CMD_WAIT; Form1->Refresh();

  try
  {
    Position=StrToInt(ParameterEdit1->Text);
  }
  catch (...)
  {
    Position=0;
  }
  FlushSerialBuffer();

  if (FileSeek_(ActualFileHandle, Position, WHENCE_SEEKSET))
    StatusLabel->Caption=CMD_SUCCESS;
  else
    StatusLabel->Caption=CMD_FAILED;
}
//---------------------------------------------------------------------------


void __fastcall TForm1::DIRButtonClick(TObject *Sender)
{
int x,y,z;
AnsiString s,t;
uint16_t Date,Time;
uint8_t Data[256];
uint32_t l;

  StatusLabel->Caption=CMD_WAIT; Form1->Refresh();

  y=Dir_(ucBuffer);
  if (y>=3) y=y-3;

  ListBox1->Clear();

  for (x=0; x<(y/sizeof(DirectoryEntryLayout_t)); x++)
  {
    if ((((DirectoryEntryLayout_t *) (&ucBuffer[x*sizeof(DirectoryEntryLayout_t)]))->Attribute) != LONG_FILENAME_ATTRIBUTE)
    {
      if ((((DirectoryEntryLayout_t *) (&ucBuffer[x*sizeof(DirectoryEntryLayout_t)]))->Attribute) == VOLUME_NAME_FLAG)
      {
        s="Datentrgername: ";
        s=s+(char)(((DirectoryEntryLayout_t *) (&ucBuffer[x*sizeof(DirectoryEntryLayout_t)]))->FileName[0]);
        s=s+(char)(((DirectoryEntryLayout_t *) (&ucBuffer[x*sizeof(DirectoryEntryLayout_t)]))->FileName[1]);
        s=s+(char)(((DirectoryEntryLayout_t *) (&ucBuffer[x*sizeof(DirectoryEntryLayout_t)]))->FileName[2]);
        s=s+(char)(((DirectoryEntryLayout_t *) (&ucBuffer[x*sizeof(DirectoryEntryLayout_t)]))->FileName[3]);
        s=s+(char)(((DirectoryEntryLayout_t *) (&ucBuffer[x*sizeof(DirectoryEntryLayout_t)]))->FileName[4]);
        s=s+(char)(((DirectoryEntryLayout_t *) (&ucBuffer[x*sizeof(DirectoryEntryLayout_t)]))->FileName[5]);
        s=s+(char)(((DirectoryEntryLayout_t *) (&ucBuffer[x*sizeof(DirectoryEntryLayout_t)]))->FileName[6]);
        s=s+(char)(((DirectoryEntryLayout_t *) (&ucBuffer[x*sizeof(DirectoryEntryLayout_t)]))->FileName[7]);
        ListBox1->Items->Add(s);
        ListBox1->Items->Add("");
      }
      else
      {
        // datum
        s="";
        Date=(((DirectoryEntryLayout_t *) (&ucBuffer[x*sizeof(DirectoryEntryLayout_t)]))->LastWriteDate);
        if (Date==0 || Date==0xFFFF)
          Date=(((DirectoryEntryLayout_t *) (&ucBuffer[x*sizeof(DirectoryEntryLayout_t)]))->CreationDate);
        DecodeDate(Date, Data);
        for (z=0; z<11; z++) s=s+(char)Data[z];
        s=s+' ';

        // zeit
        Time=(((DirectoryEntryLayout_t *) (&ucBuffer[x*sizeof(DirectoryEntryLayout_t)]))->LastWriteTime);
        if (Time==0 || Time==0xFFFF)
          Time=(((DirectoryEntryLayout_t *) (&ucBuffer[x*sizeof(DirectoryEntryLayout_t)]))->CreationTime);
        DecodeTime(Time, Data);
        for (z=0; z<6; z++) s=s+(char)Data[z];
        s=s+' ';

        if ((((DirectoryEntryLayout_t *) (&ucBuffer[x*sizeof(DirectoryEntryLayout_t)]))->Attribute) == DIRECTORY_FLAG)
        {
          s=s+"DIR  ";

          s=s+(char)(((DirectoryEntryLayout_t *) (&ucBuffer[x*sizeof(DirectoryEntryLayout_t)]))->FileName[0]);
          s=s+(char)(((DirectoryEntryLayout_t *) (&ucBuffer[x*sizeof(DirectoryEntryLayout_t)]))->FileName[1]);
          s=s+(char)(((DirectoryEntryLayout_t *) (&ucBuffer[x*sizeof(DirectoryEntryLayout_t)]))->FileName[2]);
          s=s+(char)(((DirectoryEntryLayout_t *) (&ucBuffer[x*sizeof(DirectoryEntryLayout_t)]))->FileName[3]);
          s=s+(char)(((DirectoryEntryLayout_t *) (&ucBuffer[x*sizeof(DirectoryEntryLayout_t)]))->FileName[4]);
          s=s+(char)(((DirectoryEntryLayout_t *) (&ucBuffer[x*sizeof(DirectoryEntryLayout_t)]))->FileName[5]);
          s=s+(char)(((DirectoryEntryLayout_t *) (&ucBuffer[x*sizeof(DirectoryEntryLayout_t)]))->FileName[6]);
          s=s+(char)(((DirectoryEntryLayout_t *) (&ucBuffer[x*sizeof(DirectoryEntryLayout_t)]))->FileName[7]);
          s=s+"     ";
        }
        else
        {
          s=s+"     ";

          s=s+(char)(((DirectoryEntryLayout_t *) (&ucBuffer[x*sizeof(DirectoryEntryLayout_t)]))->FileName[0]);
          s=s+(char)(((DirectoryEntryLayout_t *) (&ucBuffer[x*sizeof(DirectoryEntryLayout_t)]))->FileName[1]);
          s=s+(char)(((DirectoryEntryLayout_t *) (&ucBuffer[x*sizeof(DirectoryEntryLayout_t)]))->FileName[2]);
          s=s+(char)(((DirectoryEntryLayout_t *) (&ucBuffer[x*sizeof(DirectoryEntryLayout_t)]))->FileName[3]);
          s=s+(char)(((DirectoryEntryLayout_t *) (&ucBuffer[x*sizeof(DirectoryEntryLayout_t)]))->FileName[4]);
          s=s+(char)(((DirectoryEntryLayout_t *) (&ucBuffer[x*sizeof(DirectoryEntryLayout_t)]))->FileName[5]);
          s=s+(char)(((DirectoryEntryLayout_t *) (&ucBuffer[x*sizeof(DirectoryEntryLayout_t)]))->FileName[6]);
          s=s+(char)(((DirectoryEntryLayout_t *) (&ucBuffer[x*sizeof(DirectoryEntryLayout_t)]))->FileName[7]);
          s=s+'.';
          s=s+(char)(((DirectoryEntryLayout_t *) (&ucBuffer[x*sizeof(DirectoryEntryLayout_t)]))->FileExtension[0]);
          s=s+(char)(((DirectoryEntryLayout_t *) (&ucBuffer[x*sizeof(DirectoryEntryLayout_t)]))->FileExtension[1]);
          s=s+(char)(((DirectoryEntryLayout_t *) (&ucBuffer[x*sizeof(DirectoryEntryLayout_t)]))->FileExtension[2]);
          s=s+"  ";
          //filelnge
          l=(((DirectoryEntryLayout_t *) (&ucBuffer[x*sizeof(DirectoryEntryLayout_t)]))->FileSizeInBytes);
          s=s+l;
          s=s+"  ";
        }
        ListBox1->Items->Add(s);
      }
    }
  }
  FlushSerialBuffer();

  if (((ucBuffer[y+0] ^ ucBuffer[y+1])== ucBuffer[y+2]) && ucBuffer[y+1]!=0)
    StatusLabel->Caption=CMD_SUCCESS;
  else
    StatusLabel->Caption=CMD_FAILED;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CHANGEDIRButtonClick(TObject *Sender)
{
AnsiString s;
  StatusLabel->Caption=CMD_WAIT; Form1->Refresh();
  s=ParameterEdit1->Text+"           ";
  FlushSerialBuffer();
  if (ChangeDirectory_(s.c_str()))
    StatusLabel->Caption=CMD_SUCCESS;
  else
    StatusLabel->Caption=CMD_FAILED;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CREATEDIRButtonClick(TObject *Sender)
{
AnsiString s;
  ConvertPCTime();
  StatusLabel->Caption=CMD_WAIT; Form1->Refresh();
  s=ParameterEdit1->Text+"           ";
  FlushSerialBuffer();
  if (CreateDirectory_(s.c_str(),TimeAndDate))
    StatusLabel->Caption=CMD_SUCCESS;
  else
    StatusLabel->Caption=CMD_FAILED;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RENAMEButtonClick(TObject *Sender)
{
AnsiString s1,s2;
  ConvertPCTime();
  StatusLabel->Caption=CMD_WAIT; Form1->Refresh();
  s1=ParameterEdit1->Text+"           ";
  s2=ParameterEdit2->Text+"           ";
  FlushSerialBuffer();
  if (RenameFile_(s1.c_str(), s2.c_str(),TimeAndDate))
    StatusLabel->Caption=CMD_SUCCESS;
  else
    StatusLabel->Caption=CMD_FAILED;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::REMOVEButtonClick(TObject *Sender)
{
AnsiString s;
  StatusLabel->Caption=CMD_WAIT; Form1->Refresh();
  s=ParameterEdit1->Text+"           ";
  FlushSerialBuffer();
  if (RemoveFile_(s.c_str()))
    StatusLabel->Caption=CMD_SUCCESS;
  else
    StatusLabel->Caption=CMD_FAILED;
}


//---------------------------------------------------------------------------

void __fastcall TForm1::FORMATButtonClick(TObject *Sender)
{
  StatusLabel->Caption=CMD_WAIT; Form1->Refresh();
  if (QuickFormat_("B & S   "))
    StatusLabel->Caption=CMD_SUCCESS;
  else
    StatusLabel->Caption=CMD_FAILED;
}
//---------------------------------------------------------------------------



void __fastcall TForm1::ListBox1DblClick(TObject *Sender)
{
AnsiString s;
unsigned char c[12];
  ConvertPCTime();
  s=ListBox1->Items->Strings[ListBox1->ItemIndex];
  if (s.c_str()[19]=='D' && s.c_str()[20]=='I' && s.c_str()[21]=='R')
  {
    c[0]=s.c_str()[24];
    c[1]=s.c_str()[25];
    c[2]=s.c_str()[26];
    c[3]=s.c_str()[27];
    c[4]=s.c_str()[28];
    c[5]=s.c_str()[29];
    c[6]=s.c_str()[30];
    c[7]=s.c_str()[31];

    c[8]=s.c_str()[33];
    c[9]=s.c_str()[34];
    c[10]=s.c_str()[35];
    ChangeDirectory_(c);
    DIRButtonClick(Sender);
  }
  else if (s.c_str()[19]==' ' && s.c_str()[20]==' ' && s.c_str()[21]==' ')
  {
    c[0]=s.c_str()[24];
    c[1]=s.c_str()[25];
    c[2]=s.c_str()[26];
    c[3]=s.c_str()[27];
    c[4]=s.c_str()[28];
    c[5]=s.c_str()[29];
    c[6]=s.c_str()[30];
    c[7]=s.c_str()[31];

    c[8]=s.c_str()[33];
    c[9]=s.c_str()[34];
    c[10]=s.c_str()[35];


    if (FileOpen_(ActualFileHandle, c, FILEOPENMODE_READONLY,TimeAndDate))
    {
      StatusLabel->Caption=CMD_SUCCESS;
    }
    else
    {
      StatusLabel->Caption=CMD_FAILED;
      return;
    }

    if (FileSeek_(ActualFileHandle, 0, WHENCE_SEEKSET))
    {
      StatusLabel->Caption=CMD_SUCCESS;
    }
    else
    {
      StatusLabel->Caption=CMD_FAILED;
      return;
    }

    READButtonClick(Sender);
  }
}
//---------------------------------------------------------------------------


void __fastcall TForm1::CSpinEdit1Change(TObject *Sender)
{
  CloseSerialPort();
  DisableButtons(Sender);
  OPENSERIALButton->Enabled=true;
  PortLabel->Caption="Serial Port Closed";
}
//---------------------------------------------------------------------------

void __fastcall TForm1::WRITEButtonClick(TObject *Sender)
{
FILE *stream;
uint32_t Size,BytesWritten;
char *str1;

  ConvertPCTime();

  StatusLabel->Caption=CMD_WAIT; Form1->Refresh();

  if (OpenDialog1->Execute())
  {
    if ((stream = fopen(OpenDialog1->FileName.c_str(), "rb")) != NULL)
    {
      fseek(stream, SEEK_SET, 0);

      str1 = strrchr(OpenDialog1->FileName.c_str(), '\\');
      str1++;

      FlushSerialBuffer();
      if (FileOpen_(ActualFileHandle, str1, FILEOPENMODE_WRITE,TimeAndDate))
        StatusLabel->Caption=CMD_SUCCESS;
      else
      {
        StatusLabel->Caption=CMD_FAILED;
        return;
      }

      SectorLabel->Caption="                      ";
      SectorLabel->Refresh();

      BytesWritten=0;
      do
      {
        Size=fread(ucBuffer, sizeof(unsigned char), 512, stream);
        if (Size)
        {
          FlushSerialBuffer();
          FileWrite_(ActualFileHandle, ucBuffer, Size, 1);
          BytesWritten=BytesWritten+Size;
          SectorLabel->Caption="Sector : "+IntToStr(BytesWritten / 512);
          SectorLabel->Refresh();
        }
      }
      while (Size);

      fclose(stream);

      FlushSerialBuffer();
      if (FileClose_(ActualFileHandle,TimeAndDate))
        StatusLabel->Caption=CMD_SUCCESS;
      else
      {
        StatusLabel->Caption=CMD_FAILED;
        return;
      }
    }
  }
}
//---------------------------------------------------------------------------


void __fastcall TForm1::INITDISPLAYButtonClick(TObject *Sender)
{
  StatusLabel->Caption=CMD_WAIT; Form1->Refresh();
  if (InitDisplay_())
    StatusLabel->Caption=CMD_SUCCESS;
  else
    StatusLabel->Caption=CMD_FAILED;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CLEARDISPLAYButtonClick(TObject *Sender)
{
  StatusLabel->Caption=CMD_WAIT; Form1->Refresh();
  if (ClearDisplay_())
    StatusLabel->Caption=CMD_SUCCESS;
  else
    StatusLabel->Caption=CMD_FAILED;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DISPLAYWRITEButtonClick(TObject *Sender)
{
  StatusLabel->Caption=CMD_WAIT; Form1->Refresh();
  if (DisplayWrite_(CURSOR_2X16_LINE1_ROW1, 16, "Hallo Welt!     "))
    StatusLabel->Caption=CMD_SUCCESS;
  else
    StatusLabel->Caption=CMD_FAILED;

  FlushSerialBuffer();
  if (DisplayWrite_(CURSOR_2X16_LINE2_ROW1, 16, "Hello World!     "))
    StatusLabel->Caption=CMD_SUCCESS;
  else
    StatusLabel->Caption=CMD_FAILED;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DISPLAYOFFButtonClick(TObject *Sender)
{
  StatusLabel->Caption=CMD_WAIT; Form1->Refresh();
  if (DisplayOnOff_(0))
    StatusLabel->Caption=CMD_SUCCESS;
  else
    StatusLabel->Caption=CMD_FAILED;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DISPLAYONButtonClick(TObject *Sender)
{
  StatusLabel->Caption=CMD_WAIT; Form1->Refresh();
  if (DisplayOnOff_(1))
    StatusLabel->Caption=CMD_SUCCESS;
  else
    StatusLabel->Caption=CMD_FAILED;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CONNECTButtonClick(TObject *Sender)
{
  StatusLabel->Caption=CMD_WAIT; Form1->Refresh();
  if (Connect_())
    StatusLabel->Caption=CMD_SUCCESS;
  else
    StatusLabel->Caption=CMD_FAILED;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DISCONNECTButtonClick(TObject *Sender)
{
  StatusLabel->Caption=CMD_WAIT; Form1->Refresh();
  if (DisConnect_())
    StatusLabel->Caption=CMD_SUCCESS;
  else
    StatusLabel->Caption=CMD_FAILED;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BAUDRATEButtonClick(TObject *Sender)
{
  StatusLabel->Caption=CMD_WAIT; Form1->Refresh();

  // pc auf 9600 baud schalten
  strcpy(Parameter,Parameter9600);
  OPENSERIALButtonClick(Sender);
  FlushSerialBuffer();

  // wenn der doublestick antwortet sind 9600 baud eingestellt
  if (Ping_())
  {
    // doublestick auf 115200 baud schalten
    if (Baudrate_(115200 / 100))
    {
      // pc auch auf 115200 baud schalten
      strcpy(Parameter,Parameter115200);
      OPENSERIALButtonClick(Sender);
      FlushSerialBuffer();
      StatusLabel->Caption=CMD_SUCCESS;
    }
    else
    {
      StatusLabel->Caption=CMD_FAILED;
    }
  }
  else
  {
    // doublestick hat nicht auf 9600 baud geantwortet. doublestick ist evtl. schon auf 115200
    strcpy(Parameter,Parameter115200);
    OPENSERIALButtonClick(Sender);
    FlushSerialBuffer();
    // wenn der doublestick antwortet sind  bereits 115200 baud eingestellt
    if (Ping_())
    {
      StatusLabel->Caption=CMD_SUCCESS;
    }
    else
    {
      StatusLabel->Caption=CMD_FAILED;
    }
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::WRITEENABLEButtonClick(TObject *Sender)
{
  StatusLabel->Caption=CMD_WAIT; Form1->Refresh();
  if (WriteEnable_())
    StatusLabel->Caption=CMD_SUCCESS;
  else
    StatusLabel->Caption=CMD_FAILED;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::WRITEDISABLEButtonClick(TObject *Sender)
{
  StatusLabel->Caption=CMD_WAIT; Form1->Refresh();
  if (WriteDisable_())
    StatusLabel->Caption=CMD_SUCCESS;
  else
    StatusLabel->Caption=CMD_FAILED;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CARDSTATUSButtonClick(TObject *Sender)
{
uint8_t CardStatus;
  StatusLabel->Caption=CMD_WAIT; Form1->Refresh();
  if (GetCardStatus_(&CardStatus))
  {
    if (CardStatus & CARD_INSERTED)
      ListBox1->Items->Add("Card inserted");
    else
      ListBox1->Items->Add("No card inserted");
    if (CardStatus & CARD_WRITE_PROTECT)
      ListBox1->Items->Add("Card is write protect");
    else
      ListBox1->Items->Add("Card is not write protect");
    if (CardStatus & CARD_MOUNTED)
      ListBox1->Items->Add("Card mounted");
    else
      ListBox1->Items->Add("Card unmounted");
  }
  else
  {
    StatusLabel->Caption=CMD_FAILED;
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DIRECTIONButtonClick(TObject *Sender)
{
uint16_t Direction;
  StatusLabel->Caption=CMD_WAIT; Form1->Refresh();
  try
  {
    Direction=StrToInt(DirectionEdit->Text);
  }
  catch (...)
  {
    Direction=0;
  }
  DirectionEdit->Text=IntToStr(Direction);
  if (SetDirection_(Direction))
    StatusLabel->Caption=CMD_SUCCESS;
  else
    StatusLabel->Caption=CMD_FAILED;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::WRITEOUTPUTButtonClick(TObject *Sender)
{
uint16_t Output;
  StatusLabel->Caption=CMD_WAIT; Form1->Refresh();
  try
  {
    Output=StrToInt(WriteOutputEdit->Text);
  }
  catch (...)
  {
    Output=0;
  }
  WriteOutputEdit->Text=IntToStr(Output);
  if (SetOutput_(Output))
    StatusLabel->Caption=CMD_SUCCESS;
  else
    StatusLabel->Caption=CMD_FAILED;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PULLUPButtonClick(TObject *Sender)
{
uint16_t PullUp;
  StatusLabel->Caption=CMD_WAIT; Form1->Refresh();
  try
  {
    PullUp=StrToInt(PullUpEdit->Text);
  }
  catch (...)
  {
    PullUp=0;
  }
  PullUpEdit->Text=IntToStr(PullUp);
  if (SetPullUp_(PullUp))
    StatusLabel->Caption=CMD_SUCCESS;
  else
    StatusLabel->Caption=CMD_FAILED;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::READINPUTButtonClick(TObject *Sender)
{
uint16_t Data;
  StatusLabel->Caption=CMD_WAIT; Form1->Refresh();
  if (GetInput_(&Data))
  {
    ReadInputEdit->Text=IntToStr(Data);
    StatusLabel->Caption=CMD_SUCCESS;
  }
  else
    StatusLabel->Caption=CMD_FAILED;
  }
//---------------------------------------------------------------------------


void __fastcall TForm1::CARDAVAILABLEButtonClick(TObject *Sender)
{
  StatusLabel->Caption=CMD_WAIT; Form1->Refresh();
  if (CardAvailable_())
    StatusLabel->Caption=CMD_SUCCESS;
  else
    StatusLabel->Caption=CMD_FAILED;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CARDNOTAVAILABLEButtonClick(TObject *Sender)
{
  StatusLabel->Caption=CMD_WAIT; Form1->Refresh();
  if (CardNotAvailable_())
    StatusLabel->Caption=CMD_SUCCESS;
  else
    StatusLabel->Caption=CMD_FAILED;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::TELLButtonClick(TObject *Sender)
{
uint32_t Position=0;
  StatusLabel->Caption=CMD_WAIT; Form1->Refresh();
  FlushSerialBuffer();
  Position=FileTell_(ActualFileHandle);
  if (Position !=((uint32_t)-1))
  {
    StatusLabel->Caption=CMD_SUCCESS;
    ParameterEdit1->Text=IntToStr(Position);
  }
  else
    StatusLabel->Caption=CMD_FAILED;
}
//---------------------------------------------------------------------------



void __fastcall TForm1::FIRMWAREButtonClick(TObject *Sender)
{
uint8_t FirmwareVersion[3];
  StatusLabel->Caption=CMD_WAIT; Form1->Refresh();
  FlushSerialBuffer();
  if (GetFirmwareVersion_(FirmwareVersion))
  {
    FirmwareEdit->Text=IntToStr(FirmwareVersion[0])+'.'+IntToStr(FirmwareVersion[1])+'.'+IntToStr(FirmwareVersion[2]);
    StatusLabel->Caption=CMD_SUCCESS;
    ParameterEdit1->Text=IntToStr(Position);
  }
  else
    StatusLabel->Caption=CMD_FAILED;
}
//---------------------------------------------------------------------------


void __fastcall TForm1::FileHandleRadioButton1Click(TObject *Sender)
{
  if      (FileHandleRadioButton1->Checked==true) ActualFileHandle=0;
  else if (FileHandleRadioButton2->Checked==true) ActualFileHandle=1;
  else if (FileHandleRadioButton3->Checked==true) ActualFileHandle=2;
  else if (FileHandleRadioButton4->Checked==true) ActualFileHandle=3;
}
//---------------------------------------------------------------------------


void __fastcall TForm1::PingButtonClick(TObject *Sender)
{
  StatusLabel->Caption=CMD_WAIT; Form1->Refresh();
  if (Ping_())
  {
    StatusLabel->Caption=CMD_SUCCESS;
    ListBox1->Items->Add("Ping ok");
  }
  else
  {
    StatusLabel->Caption=CMD_FAILED;
    ListBox1->Items->Add("Ping failed");
  }  
}
//---------------------------------------------------------------------------

