{
 Engelmann & Schrader GmbH (c) 2006 www.engelmann-schrader.de

 Die Programme dienen ausschliesslich der Information. Es gibt
 weder eine Gewaehrleistung noch wird irgendeine Eigenschaft
 zugesichert. Die Verantwortung fuer den Einsatz von Programm
 bzw. Quelltext liegt vollstaendig beim Anwender.
}
PROGRAM CopyS ;

USES RS232, Stick, Param ;

CONST
  TimeAndDate : TTimeAndDate =
   (Second :    0 ;
    Hour   :   12 ;
    Minute :    5 ;
    Day    :   25 ;
    Month  :    8 ;
    Year   : 2005 ) ;

  Handle = 0 ;

PROCEDURE Help ;
BEGIN
  WRITELN ;
  WRITELN ('USAGE:  CopyS [s:]name1 [[s:]name2] [/n]') ;
  WRITELN ('Copies file name1( usb stick ) to file name2( PC )') ;
  WRITELN ('name1:  source filename') ;
  WRITELN ('name2:  target filename (optional, default is name1 = name2)') ;
  WRITELN ('s:      the stick is always device S. Name1 or name2 have to precede by S:') ;
  WRITELN ('/n:     com interface ( /1 to /4 ) (optional, default is /1)') ;
  WRITELN ;
  WRITELN ('Examples:') ;
  WRITELN ('CopyS S:LETTER.TXT') ;
  WRITELN ('Copies the file LETTER.TXT from the stick to the current directory.');
  WRITELN ('CopyS LETTER.TXT S:') ;
  WRITELN ('Copies the file LETTER.TXT from current directory to the stick.');
  WRITELN ;
END ;

PROCEDURE CopyFromCard ( sourcename:STRING; targetname:STRING );
VAR
  targetfile : FILE OF BYTE ;
  I          : WORD ;
  C          : BYTE ;
  filelength : LONGINT ;
BEGIN
  ASSIGN (targetfile, targetname) ;
  REWRITE (targetfile) ;

  IF ( FILEOPEN ( Handle, FileOpenMode_READONLY, TimeAndDate, sourcename ) ) THEN
    BEGIN
      FILESEEK ( Handle, 0, WHENCE_SEEKEND ) ;
      filelength := FILETELL ( Handle )  ;
      FILESEEK ( Handle, 0, WHENCE_SEEKSET ) ;

      WHILE filelength > 0 DO
        BEGIN
          IF filelength > 512 THEN
            I := 512
          ELSE
            I := filelength ;
          filelength := filelength - I ;
          FILEREAD ( Handle, I ) ;
          WHILE I > 0  DO
            BEGIN
              C := getchar ;
              WRITE (targetfile, C ) ;
              DEC ( I ) ;
            END ;
          GetResult ;
        END ;
      FILECLOSE ( Handle, TimeAndDate ) ;
    END
  ELSE
    WRITELN ( sourcename, ' not found!' ) ;
  CLOSE (targetfile) ;
END ;

PROCEDURE CopytoCard ( sourcename:STRING; targetname:STRING );
VAR
  sourcefile : FILE OF BYTE ;
  I          : WORD ;
  C          : BYTE ;
  filelength : LONGINT ;
  databuffer : ARRAY [0..511] OF BYTE ;
  datalength : WORD ;
BEGIN
  ASSIGN (sourcefile, sourcename) ;
  RESET (sourcefile) ;

  IF ( FILEOPEN ( Handle, FileOpenMode_WRITE, TimeAndDate, targetname ) ) THEN
    BEGIN
      filelength := FileSize ( sourcefile )  ;

      WHILE filelength > 0 DO
        BEGIN
          IF filelength > 512 THEN
            datalength := 512
          ELSE
            datalength := filelength ;
          filelength := filelength - datalength ;

          FOR I := 0  TO datalength - 1 DO
            BEGIN
              READ ( sourcefile, C ) ;
              Databuffer[I] := C ;
            END ;

          FILEWRITE ( Handle, datalength, databuffer ) ;

        END ;
      FILECLOSE ( Handle, TimeAndDate ) ;
    END
  ELSE
    WRITELN ( ' Can''t open ' , targetname,' on stick!' ) ;
  CLOSE (sourcefile) ;
END ;

PROCEDURE CopyDirection ;
BEGIN
  IF Direction = FromCard THEN
    BEGIN
      copyfromcard ( asourcename, atargetname ) ;
    END
  ELSE IF Direction = ToCard THEN
    BEGIN
      copytocard ( asourcename, atargetname )
    END
  ELSE
    Help ;
END ;

BEGIN
  Getparameter ;
  IF ( (asourcename <> '') AND (atargetname <> '') ) THEN
    BEGIN
      RS232.Init ;
      Mount ;
      CopyDirection ;
      UnMount ;
      RS232.DONE ;
    END
  ELSE
    Help ;
END .
