{
 Engelmann & Schrader GmbH (c) 2006 www.engelmann-schrader.de

 Die Programme dienen ausschliesslich der Information. Es gibt
 weder eine Gewaehrleistung noch wird irgendeine Eigenschaft
 zugesichert. Die Verantwortung fuer den Einsatz von Programm
 bzw. Quelltext liegt vollstaendig beim Anwender.
}
UNIT Stick ;
INTERFACE
USES RS232, Param ;


TYPE TTimeAndDate =
  RECORD
    Second : BYTE ;
    Hour   : BYTE ;
    Minute : BYTE ;
    Day    : BYTE ;
    Month  : BYTE ;
    Year  : WORD ;
  END ;

CONST
 cmdFORMAT                           = $01 ;
 cmdOPEN                             = $02 ;
 cmdCLOSE                            = $03 ;
 cmdCREATE_DIRECTORY                 = $04 ;
 CHANGE_DIRECTORY                    = $05 ;
 cmdREAD                             = $06 ;
 cmdWRITE                            = $07 ;
 cmdSEEK                             = $08 ;
 cdmRENAME                           = $09 ;
 cmdREMOVE                           = $0A ;
 cmdDIR                              = $0B ;
 cmdTELL                             = $0C ;

 cmdWRITE_ENABLE                     = $21 ;
 cmdWRITE_DISABLE                    = $22 ;
 cmdCONNECT                          = $23 ;
 cmdDISCONNECT                       = $24 ;
 cmdCARD_AVAILABLE                   = $25 ;
 cmdCARD_NOT_AVAILABLE               = $26 ;

 cmdMOUNT                            = $41 ;
 cmdUNMOUNT                          = $42 ;
 cmdGET_CARD_STATUS                  = $43 ;

 (* DISPLAY *)
 cmdINIT_DISPLAY                     = $61 ;
 cmdCLEAR_DISPLAY                    = $62 ;
 cmdDISPLAY_WRITE                    = $64 ;
 cmdDISPLAY_ONOFF                    = $65 ;

 CURSOR_1X16_LINE1_ROW1              = $00 ;
 CURSOR_2X16_LINE1_ROW1              = $00 ;
 CURSOR_2X16_LINE2_ROW1              = $40 ;
 CURSOR_4X20_LINE1_ROW1              = $00 ;
 CURSOR_4X20_LINE2_ROW1              = $40 ;
 CURSOR_4X20_LINE3_ROW1              = $14 ;
 CURSOR_4X20_LINE4_ROW1              = $54 ;

 cmdBAUDRATE                         = $A1 ;
 cmdPING                             = $A2 ;

 IO_SET_DIRECTION                    = $C1 ;
 IO_SET_PULLUP                       = $C2 ;
 IO_GET_INPUT                        = $C3 ;
 IO_SET_OUTPUT                       = $C4 ;

 FILEOPENMODE_READONLY               = $01 ;
 FILEOPENMODE_WRITE                  = $02 ;
 FILEOPENMODE_APPEND                 = $03 ;

 READ_ONLY_FLAG                      = (1 SHL 0) ;
 HIDDEN_FLAG                         = (1 SHL 1) ;
 SYSTEM_FLAG                         = (1 SHL 2) ;
 VOLUME_NAME_FLAG                    = (1 SHL 3) ;
 DIRECTORY_FLAG                      = (1 SHL 4) ;
 ACHIEVE_FLAG                        = (1 SHL 5) ;

 CARD_INSERT                         = (1 SHL 0) ;
 CARD_WRITE_PROTECT                  = (1 SHL 1) ;

 WHENCE_SEEKSET                      = 0 ;
 WHENCE_SEEKCUR                      = 1 ;
 WHENCE_SEEKEND                      = 2 ;

  PROCEDURE FILECLOSE ( Handle:BYTE; TimeAndDate:TTimeAndDate ) ;
  PROCEDURE FILEREAD ( Handle:BYTE; count : WORD );
  FUNCTION  FILEWRITE ( Handle:BYTE; count : WORD; VAR databuffer : ARRAY OF BYTE ) : BOOLEAN ;
  FUNCTION  FILEOPEN ( Handle:BYTE; FileOpenMode:BYTE; TimeANdDate:TTimeAndDate; filename:STRING ) : BOOLEAN;
  FUNCTION  FileTell ( Handle : BYTE ) : LONGINT ;
  PROCEDURE FileSeek ( handle : BYTE; position : LONGINT ; whence : BYTE ) ;
  FUNCTION  GetResult:BOOLEAN ;
  FUNCTION  Mount : BOOLEAN ;
  PROCEDURE UnMount ;
  PROCEDURE Dir ;
  FUNCTION GetCardStatus ( VAR Cardstatus : BYTE ) : BOOLEAN ;
  FUNCTION Baudrate ( BitProS : WORD ) : BOOLEAN ;
  FUNCTION  Ping : BOOLEAN ;
  FUNCTION RemoveFile ( filename : STRING ) : BOOLEAN ;
  FUNCTION WriteEnable : BOOLEAN ;
  FUNCTION WriteDisable : BOOLEAN ;

IMPLEMENTATION

VAR
  Name8Ext3  : ARRAY [0..10] OF BYTE ;
  buffer     : ARRAY [0..$1FF] OF BYTE ;

PROCEDURE FilenameToBuffer (Filename:STRING) ;
VAR
  I : INTEGER ;
  T : INTEGER ;
BEGIN

  FOR I := 0 TO 10 DO
    Name8Ext3[I] := BYTE (' ') ;

  T := 0 ;
  FOR I := 1 TO Length ( Filename ) DO
    BEGIN
      IF Filename[I] = '.' THEN
        T := 8
      ELSE
        BEGIN
          Name8Ext3[T] := BYTE( UpCase(Filename[I]) ) ;
          INC (T) ;
        END ;
    END ;

END ;

PROCEDURE sendcommand ;
VAR
  checksum : BYTE ;
  count    : WORD ;
  I        : WORD ;
BEGIN
  (*FlushSerialBuffer();*)
  checksum := 0 ;
  count    := Buffer[1] + 256 * Buffer[2] ;
  FOR I := 0 TO count - 2 DO
    BEGIN
      checksum := checksum XOR Buffer[I] ;
      PutChar ( Buffer[I] ) ;
    END ;

  PutChar ( checksum ) ;
END ;

FUNCTION GetResult:BOOLEAN ;
VAR
  R0, R1, R2:BYTE ;
BEGIN
   R0 := Getchar ;
   R1 := Getchar ;
   R2 := Getchar ;

   IF DEBUG THEN
     WRITELN ( R0:4, R1:4, R2:4 ) ;

   IF (R0 XOR R1 XOR R2) = 0 THEN
     GetResult := R1 = 1
   ELSE
     GetResult := FALSE ;
END ;

FUNCTION Ping : BOOLEAN ;
BEGIN
  Buffer[ 0] := cmdPING ;
  Buffer[ 1] := 4 ;
  Buffer[ 2] := 0 ;

  SendCommand ;

  Ping := GetResult ;
END ;

(* GetCardStatus
// Liest den aktuellen Status der Kartenhalterkontakte
// Bit 0: 1 Karte eingelegt, 0 keine Karte eingelegt
// Bit 1: 1 Karte schreibgeschtzt, 0 Karte nicht schreibgeschtzt
// #define CARD_INSERTED	   (1 << 0)
// #define CARD_WRITE_PROTECT  (1 << 1)*)
FUNCTION GetCardStatus ( VAR Cardstatus : BYTE ) : BOOLEAN ;
BEGIN
  Buffer[ 0] := cmdGET_CARD_STATUS ;
  Buffer[ 1] := 4 ;
  Buffer[ 2] := 0 ;

  SendCommand ;

  CardStatus := Getchar ;

  GetCardStatus := GetResult ;
END ;

FUNCTION Baudrate ( BitProS : WORD ) : BOOLEAN ;
BEGIN
  Buffer[ 0] := cmdBAUDRATE;
  Buffer[ 1] := 8 ;
  Buffer[ 2] := 0 ;

  Buffer[ 3] := 2 ;
  Buffer[ 4] := 0 ;
  Buffer[ 5] := BitProS MOD 256 ;
  Buffer[ 6] := BitProS DIV 256 ;

  SendCommand ;

  Baudrate := GetResult ;
END ;

(*Initialization MMC/SD-Card. Reads the file system.*)
FUNCTION Mount : BOOLEAN ;
BEGIN
  Buffer[0] := cmdMOUNT ;    (* command                  *)
  Buffer[1] := $04 ;         (* overall length low byte  *)
  Buffer[2] := $00 ;         (* overall length high byte *)

  SendCommand;

  Mount := GetResult ;
END ;

PROCEDURE UnMount ;
BEGIN

  Buffer[0] := cmdUNMOUNT ;  (* command          *)
  Buffer[1] := $04 ;         (* length low byte  *)
  Buffer[2] := $00 ;         (* length high byte *)

  SendCommand;

  GetResult ;

END ;

PROCEDURE Dir ;
BEGIN
  Buffer[ 0] := cmdDIR ;
  Buffer[ 1] := 4 ;
  Buffer[ 2] := 0 ;
  SendCommand ;
END ;


PROCEDURE FileSeek ( handle : BYTE; position : LONGINT ; whence : BYTE ) ;
BEGIN
  Buffer[ 0] := cmdSEEK;
  Buffer[ 1] := 17;
  Buffer[ 2] := 0;

  Buffer[ 3] := 1;      (* length handle low byte *)
  Buffer[ 4] := 0;
  Buffer[ 5] := Handle;

  Buffer[ 6] := 4;      (* length position low byte *)
  Buffer[ 7] := 0;
  Buffer[ 8] :=  Position         AND $FF;
  Buffer[ 9] := (Position SHR  8) AND $FF;
  Buffer[10] := (Position SHR 16) AND $FF;
  Buffer[11] := (Position SHR 24) AND $FF;

  Buffer[12] := 2;      (* length whence low byte *)
  Buffer[13] := 0;

  Buffer[14] := Whence MOD 256 ;
  Buffer[15] := Whence DIV 256 ;

  SendCommand ;

  GetResult ;
END ;


(* *)
FUNCTION FileTell ( Handle : BYTE ) : LONGINT ;
VAR
  position : LONGINT ;
BEGIN
  Buffer[ 0] := cmdTELL ;

  Buffer[ 1] := 7 ;
  Buffer[ 2] := 0 ;

  Buffer[ 3] := 1 ;
  Buffer[ 4] := 0 ;
  Buffer[ 5] := Handle ;

  SendCommand ;

  position := LONGINT ( Getchar ) ;
  position := position + LONGINT ( Getchar ) * LONGINT (     $100 ) ;
  position := position + LONGINT ( Getchar ) * LONGINT (   $10000 ) ;
  position := position + LONGINT ( Getchar ) * LONGINT ( $1000000 ) ;

  GetResult ;

  FileTell := position ;
END ;


(* *)
FUNCTION FILEOPEN ( Handle:BYTE; FileOpenMode:BYTE; TimeANdDate:TTimeAndDate; filename:STRING ) : BOOLEAN ;
BEGIN
  FileNameToBuffer ( filename ) ;
  Buffer[ 0] := cmdOPEN ;
  Buffer[ 1] := 32 ;
  Buffer[ 2] := 0 ;
  Buffer[ 3] := 1 ;              (* length handle low byte    *)
  Buffer[ 4] := 0 ;              (* length handle high byte   *)
  Buffer[ 5] := Handle ;         (* handle                    *)
  Buffer[ 6] := 11 ;             (* length filename low byte  *)
  Buffer[ 7] := 0;               (* length filename high byte *)
  Buffer[ 8] := Name8Ext3[0] ;   (* filename without dot      *)
  Buffer[ 9] := Name8Ext3[1] ;
  Buffer[10] := Name8Ext3[2] ;
  Buffer[11] := Name8Ext3[3] ;
  Buffer[12] := Name8Ext3[4] ;
  Buffer[13] := Name8Ext3[5] ;
  Buffer[14] := Name8Ext3[6] ;
  Buffer[15] := Name8Ext3[7] ;
  Buffer[16] := Name8Ext3[8] ;
  Buffer[17] := Name8Ext3[9] ;
  Buffer[18] := Name8Ext3[10] ;
  Buffer[19] := 1 ;              (* length filemode           *)
  Buffer[20] := 0 ;
  Buffer[21] := FileOpenMode ;
  Buffer[22] := 7;               (* length time and date      *)
  Buffer[23] := 0;
  Buffer[24] := TimeAndDate.Second;
  Buffer[25] := TimeAndDate.Minute;
  Buffer[26] := TimeAndDate.Hour;
  Buffer[27] := TimeAndDate.Day;
  Buffer[28] := TimeAndDate.Month;
  Buffer[29] := TimeAndDate.Year MOD 256 ;
  Buffer[30] := TimeAndDate.Year DIV 256 ;

  SendCommand;

  FILEOPEN := GetResult;
END ;

(*
  Die Funktion FileRead_ gibt als Rckgabewert die Anzahl der gelesenen Zeichen
  // zurck. Daher muss die berprfung der Datenblockchecksumme durch die Funktion
  // erfolgen, die FileRead_ aufruft!

*)

PROCEDURE FILEREAD ( Handle:BYTE; count : WORD );
BEGIN

  Buffer[ 0] := cmdREAD ;
  Buffer[ 1] := 15 ;
  Buffer[ 2] := 0 ;

  Buffer[ 3] := 1 ;
  Buffer[ 4] := 0 ;
  Buffer[ 5] := Handle ;

  Buffer[ 6] := 2 ;
  Buffer[ 7] := 0 ;
  Buffer[ 8] := count MOD 256 ; (* length of data to read low byte  *)
  Buffer[ 9] := count DIV 256 ; (* length of data to read high byte *)

  Buffer[10] := 2;                      (* length of size low byte  *)
  Buffer[11] := 0;                      (* length of size high byte *)
  Buffer[12] := 1 ;                     (* size low byte            *)
  Buffer[13] := 0 ;                     (* size high byte           *)

  SendCommand ;

 (* Die Funktion FileRead_ gibt als Rckgabewert die Anzahl der gelesenen Zeichen
  // zurck. Daher muss die berprfung der Datenblockchecksumme durch die Funktion
  // erfolgen, die FileRead_ aufruft!*)
END ;

FUNCTION FILEWRITE ( Handle:BYTE; count : WORD; VAR databuffer : ARRAY OF BYTE ) : BOOLEAN ;
VAR
  I : WORD ;
BEGIN
  Buffer[ 0] := cmdWrite ;
  Buffer[ 1] := ( 18 + Count ) MOD 256 ;
  Buffer[ 2] := ( 18 + Count ) DIV 256 ;

  Buffer[ 3] := 1 ;
  Buffer[ 4] := 0 ;
  Buffer[ 5] := Handle ;

  Buffer[ 6] := 2 ;
  Buffer[ 7] := 0 ;
  Buffer[ 8] := count MOD 256 ; (* length of data to write low byte  *)
  Buffer[ 9] := count DIV 256 ; (* length of data to write high byte *)

  Buffer[10] := 2;                      (* length of size low byte  *)
  Buffer[11] := 0;                      (* length of size high byte *)
  Buffer[12] := 1 ;                     (* size low byte            *)
  Buffer[13] := 0 ;                     (* size high byte           *)

  Buffer[14] := count MOD 256 ;
  Buffer[15] := count DIV 256 ;

  FOR I := 0 TO Count - 1 DO
    Buffer[16 + I] := databuffer[I] ;

  SendCommand ;

  FileWrite := GetResult ;
END ;

PROCEDURE FILECLOSE ( Handle:BYTE; TimeAndDate:TTimeAndDate );
BEGIN
  Buffer[ 0] := cmdCLOSE;
  Buffer[ 1] := 16;
  Buffer[ 2] := 0;

  Buffer[ 3] := 1;
  Buffer[ 4] := 0;
  Buffer[ 5] := Handle;
  Buffer[ 6] := 7;
  Buffer[ 7] := 0;
  Buffer[ 8] := TimeAndDate.Second;
  Buffer[ 9] := TimeAndDate.Minute;
  Buffer[10] := TimeAndDate.Hour;
  Buffer[11] := TimeAndDate.Day;
  Buffer[12] := TimeAndDate.Month;
  Buffer[13] := TimeAndDate.Year MOD 256 ;
  Buffer[14] := TimeAndDate.Year DIV 256 ;

  SendCommand;
  GetResult ;
END ;


FUNCTION WriteDisable : BOOLEAN ;
BEGIN
  Buffer[ 0] := cmdWRITE_DISABLE;
  Buffer[ 1] := 4;
  Buffer[ 2] := 0;
  SendCommand ;
  WriteDisable :=  GetResult ;
END ;

FUNCTION WriteEnable : BOOLEAN ;
BEGIN
  Buffer[ 0] := cmdWRITE_Enable;
  Buffer[ 1] := 4;
  Buffer[ 2] := 0;
  SendCommand ;
  WriteEnable :=  GetResult ;
END ;

FUNCTION RemoveFile ( filename : STRING ) : BOOLEAN ;
BEGIN
  FileNameToBuffer ( filename ) ;
  Buffer[ 0] := cmdREMOVE;
  Buffer[ 1] := 17;              (* length command            *)
  Buffer[ 2] := 0;

  Buffer[ 3] := 11;              (* length file name          *)
  Buffer[ 4] := 0;

  Buffer[ 5] := Name8Ext3[0] ;   (* filename without dot      *)
  Buffer[ 6] := Name8Ext3[1] ;
  Buffer[ 7] := Name8Ext3[2] ;
  Buffer[ 8] := Name8Ext3[3] ;
  Buffer[ 9] := Name8Ext3[4] ;
  Buffer[10] := Name8Ext3[5] ;
  Buffer[11] := Name8Ext3[6] ;
  Buffer[12] := Name8Ext3[7] ;
  Buffer[13] := Name8Ext3[8] ;
  Buffer[14] := Name8Ext3[9] ;
  Buffer[15] := Name8Ext3[10] ;

  SendCommand ;
  RemoveFile := GetResult ;
END ;

END.